/*
	CGI Source for Guest book

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: February 23, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc version 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#ifndef __MyCgi_h_
#define __MyCgi_h_

#include "stdio.h"
#include "Config.h"

#ifndef __cplusplus
#error	"This program isn't supported in Non-C++ code"
#endif

#ifdef SUNOS
#define		SEEK_SET	0
#define		SEEK_CUR	1
#define		SEEK_END	2

void	_fgetpos	(FILE *fpt, long *pos);
void	_fsetpos	(FILE *fpt, long *pos);
#endif

#ifndef _fpos_t
typedef	long	fpos_t;
#endif

enum stat { ERR = -1, OK = 1 };

#define	CR		13
#define	LF		10
#define MAX_ENTRIES	100

#define	MAX_MAX_LEN	255

typedef struct tagENTRY
{
    char *f_name;
    char *f_val;
} ENTRY;

typedef struct tagHEADER
{
	char	szIndex[10];		/* number of guestbook#.html	*/
	char	szTotal[10];		/* total html file #		*/
	char	szBoardNum[5];		/* number of page 'guest#.html'	*/
	char	szDummy[100];		/* dummy space			*/
} HEADER;
						
typedef struct tagRECORD
{
	char	szNumber[5];		/* number of guest book	*/
	char	szName[20];		/* name of guest	*/
	char	szDate[20];		/* date			*/
	char	szTime[20];		/* time 		*/
	char	szEmail[40];		/* email		*/
	char	szCount[10];		/* count that is read by someone*/
	char	szTitle[80];		/* title		*/
	char	szLine[5];		/* number of line	*/
	char	szHomePage[60];		/* home page address	*/
	char	szDomain[50];		/* home page domain	*/
	char	szHtmlName[100];	/* html file name 	*/
} RECORD;

#define	HEADER_SIZE	(sizeof(HEADER))
#define	RECORD_SIZE	(sizeof(RECORD))
#define	ENTRY_SIZE	(sizeof(ENTRY))

/*
** Prototype for MyUtil.c
*/
#ifdef __cplusplus
extern "C" {
#endif 

void getword		(char *word, char *line, char stop);
char *makeword		(char *line, char stop);
char *fmakeword		(FILE *f, char stop, int *cl);
char x2c		(char *what);
void unescape_url	(char *url);
void plustospace	(char *str);
int rind		(char *s, char c);
int getline		(char *s, int n, FILE *f);
void send_fd		(FILE *f, FILE *fd);
int ind			(char *s, char c);
void escape_shell_cmd	(char *cmd);

int	EatWs		(FILE *fpt);
int	CfgGetLine	(char *str, int n, FILE *fpt);
void	CfgGetWord	(char *word, char *line);

#ifdef __cplusplus
}
#endif

#endif	/* __MyCgi_h_	*/
