/*
	CGI Source for TextBoard.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc version 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "TextBoard.h"
#include <stdio.h>
#include <stdlib.h>

TextBoard::TextBoard()
{
	hdr	= new HEADER;
	rcd	= new RECORD;
	iParam	= new ENTRY[MAX_ENTRIES];

	buf	= NULL;
	fpt	= NULL;
	
	strcpy(szBaseDir, "");
	strcpy(szBbsDir, "");
	strcpy(szEmail, "");
	strcpy(szPassword, "");

	iBoardNum = 0;
	iTextNum  = 0;
	iTotal	  = 0;

	iStart	  = 0;
	iEnd	  = 0;
}

TextBoard::~TextBoard()
{
	delete	hdr;
	delete	rcd;
	delete	iParam;

	buf	= NULL;
}

char *TextBoard::ItoA(int num, char *str)
{
	sprintf(str, "%d", num);

	return	str;
}
	
stat TextBoard::ProcessConfig()
{
	char	l[MAX_STRING_LEN] = "", w[MAX_STRING_LEN] = "", str[MAX_STRING_LEN] = "";
	char	w2[MAX_STRING_LEN] = "";
	char	tmp[MAX_STRING_LEN] = "";
	int	i = 0;
	Config	MyConfig(l, w);

	/*
	** Open config file
	*/
	fpt = fopen("GuestBook.conf", "r");

	if (fpt == NULL)
	{
		char	str[MAX_STRING_LEN];

		sprintf(str, "<font color=228b22 size=3>Can't open 'GuestBook.conf'!!!</font><br>");
		ShowError(str);
		exit(1);
	}

	/*
	** Parse config file. Remind me to learn yacc.
	*/
	while (!MyConfig.CfgGetLine(l, MAX_STRING_LEN, fpt))
	{
		i++;

		if (l[0] != '#' && l[0] != '\0')
		{
			MyConfig.CfgGetWord(w, l);

			if (!strcmp(w, "BASE_DIR"))
				strcpy(szBaseDir, l);
			else if (!strcmp(w, "BBS_DIR"))
				strcpy(tmp, l);
			else if (!strcmp(w, "EMAIL"))
				strcpy(szEmail, l);
			else if (!strcmp(w, "Password"))
		//		strcpy(szPassword, l);
				strcpy(szPassword, "ajfEnd");	/* For security	*/
			else if (!strcmp(w, (char *)ItoA(GetBoardNum(), str)))
			{
				MyConfig.CfgGetWord(w, l);	/* guest.gif	*/
				MyConfig.CfgGetWord(w2, l);	/* Email	*/
				strcpy(szImageName, w);
				sprintf(szBbsDir, "%s%d%s", tmp, GetBoardNum(), "/");
				if (strcmp(w2, ""))
					strcpy(szEmail, w2);	/* Email	*/
			}
		}
	}

	fclose(fpt);

#ifdef _DEBUG_
	printf("BASE_DIR : %s%c<br>", GetBaseDir(), LF);
	printf("BBS_DIR  : %s%c<br>", GetBbsDir(), LF);
	printf("ERASE_DOMAIN : %s%c<br>", GetEraseDomain(), LF);
	printf("EMAIL    : %s%c<br>", GetEmail(), LF);
	printf("Image	 : %s%c<br>", GetImageFileName(), LF);
#endif

	return	OK;
}

void TextBoard::GetEnv()
{
	/*
	** Get environment variable from HTTP
	*/
	buf = getenv("QUERY_STRING");

	for (int i=0; i<2; i++)
	{
		(iParam+i)->f_val  = (char *)makeword(buf, '&');
		(iParam+i)->f_name = (char *)makeword((iParam+i)->f_val, '=');
#ifdef _DEBUG_
	printf("%s%c", (iParam+i)->f_name, LF);
	printf("%s%c%s", (iParam+i)->f_val, LF, "<br>");
#endif
	}

	/*
	** Set iBoardNum and iTextNum
	*/
	iBoardNum = atoi((iParam+0)->f_val);
	iTextNum  = atoi((iParam+1)->f_val);

#ifdef _DEBUG_
	printf("iBoardNum = %d%c", iBoardNum, LF);
	printf("iTextNum = %d%c", iTextNum, LF);
#endif
	/*
	** Get Config from 'GuestBook.conf'
	*/
	ProcessConfig();
}

stat TextBoard::IsGuestBookStart()
{
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");
	fpt = fopen(fname, "r");

	/*
	** fname doesn't exist.
	*/
	if (fpt == NULL)
	{
		ShowStartHtmlPage();

		return ERR;		/* start	*/
	}

	fread(hdr, HEADER_SIZE, 1, fpt);
	iTotal = atoi(hdr->szTotal);

	fclose(fpt);
	return	OK;			/* non-start	*/
}

void TextBoard::ShowInitHtmlPage()
{
	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.13</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=ffffff>%c", LF);

	printf("<center>%c", LF);
	printf("<img src=%sImage/%s width=200 height=60 border=0>%c", GetBaseDir(), GetImageFileName(), LF);

	printf("<table border=0 width=480 cellspace=3>%c", LF);
		printf("<tr>%c", LF);
			printf("<td valign=buttom>%c", LF);
			printf("<img align=left border=0 src=%sImage/bookpen.gif>%c", GetBaseDir(), LF);

			printf("<br>%c", LF);
			printf("<img width=420 src=%sImage/line_ani.gif>%c", GetBaseDir(), LF);
			printf("</td>%c", LF);
		printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);
	printf("<center>%c", LF);
	printf("<table border=0 align=center><tr><th><font size=-1>۹ȣ</font></th><th><font size=-1>۾</font></th><th><font size=-1>۾¥</font></th><th><font size=-1>Ƚ</font></th><th><font size=-1>ټ</font></th><th><font size=-1></font></th></tr>%c", LF);
}

int TextBoard::GetTotalText()
{
	
	return	iTotal;
}	

int TextBoard::GetBoardNum()
{
	return	iBoardNum;
}

int TextBoard::GetTextNum()
{
	return	iTextNum;
}

char* TextBoard::GetBaseDir()
{
	return	szBaseDir;
}

char* TextBoard::GetBbsDir()
{
	return	szBbsDir;
}

char* TextBoard::GetEmail()
{
	return	szEmail;
}

char* TextBoard::GetImageFileName()
{
	return	szImageName;
}

char* TextBoard::GetPassword()
{
	return	szPassword;
}

void TextBoard::GetScope()
{
#ifdef _DEBUG_
	printf("iBoardNum = %d iTextNum = %d%c", iBoardNum, iTextNum, LF);
#endif

	/*
	** iStart(1) < iEnd(10)
	*/
	if (GetTotalText() > 0 && GetTotalText() < 11)
	{
		iStart = 1;
		iEnd   = GetTotalText();
	}
	else	/* total > 11 */
	{
		/*if (iBoardNum == 0 && iTextNum == 0)*/
		if (GetTextNum() == 0)
		{
			iStart = GetTotalText() - 9;
			iEnd   = GetTotalText();
		}
		else
		{
			iStart = GetTextNum() - 9;
			iEnd   = GetTextNum();
		
			if (iStart <= 0)
			{
				iStart = 1;
				iEnd   = 10;
				
				iEnd = (iEnd >= GetTotalText()) ? GetTotalText() : iEnd;
			}
		}
	}

#ifdef _DEBUG_
	printf("iStart = %d, iEnd = %d, iTotal = %d%c", iStart, iEnd, GetTotalText(), LF);
#endif
}

void TextBoard::ShowBoard()
{
	int	i, iLeftTextNum, iRightTextNum;
	long	lSize;

	/*
	** Open data file ('guest.dat')
	*/
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");

	fpt = fopen(fname, "r");

	if (fpt == NULL)
	{
		char str[MAX_STRING_LEN];

		sprintf(str, "<font color=228b22 size=3>Can't open %s.</font><br>", fname);
		ShowError(str);
		exit(1);
	}

	for (i=iEnd; i>=iStart; i--)
	{
		lSize = (iTotal - i + 1) * -(RECORD_SIZE);

#ifdef _DEBUG_
	printf("lSize = %ld%c", lSize, LF);
#endif
        	fseek(fpt, lSize, SEEK_END);
		fread(rcd, RECORD_SIZE, 1, fpt);

		printf("<tr>");
		printf("<td bgcolor=#f0f0e0 align=center><font size=-1>%s</font></td>", rcd->szNumber);

		if (!strcmp(rcd->szEmail, ""))
		{
			printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", rcd->szName);
		}
		else
		{
			printf("<td bgcolor=#d0eeed align=center><font size=-1><a href=mailto:%s></font><font size=-1>%s</font></a></td>", rcd->szEmail, rcd->szName);
		}
		printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", rcd->szDate);
		printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", rcd->szCount);
		printf("<td bgcolor=#d0eeed align=center><font size=-1>%s</font></td>", rcd->szLine);
		printf("<td bgcolor=#d0eeed align=center><a href=%scgi-bin/TextRead.Cgi?BoardNum=%d&TextNum=%s><font size=-1>%s</font></a></td></tr>%c%c", GetBaseDir(), GetBoardNum(), rcd->szNumber, rcd->szTitle, LF, LF);
	}

	printf("</table>%c", LF);
	printf("</center>%c", LF);

	iLeftTextNum = iStart - 1;

	printf("<br>%c", LF);
	printf("<center>%c", LF);

	if (iLeftTextNum != 0)
	{
		printf("<a href=%scgi-bin/TextBoard.Cgi?BoardNum=%d&TextNum=%d>", GetBaseDir(), GetBoardNum(), iLeftTextNum);
		printf("<img src=%sImage/leftarrow.gif border=0></a>%c", GetBaseDir(), LF);
	}

	printf("<a href=%scgi-bin/TextHtml.Cgi?BoardNum=%d&BoardNum=-1><img src=%sImage/posting.gif align=absmiddle border=0></a>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);

	printf("</center>%c", LF);

	printf("<p>%c", LF);
	printf("<center>%c", LF);
	printf("<img src=%sImage/line.gif>%c", GetBaseDir(), LF);
	printf("<br>%c", LF);

	printf("<font color=4a708b size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.13 <b>Software Engineering Lab.</b> All rights reserved.<br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", GetEmail(), GetEmail(), LF);
	printf("</font></center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);

	fclose(fpt);
}

void TextBoard::ShowStartHtmlPage()
{
	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.13</title>%c", LF);
	printf("</head>%c", LF);

	printf("<body bgcolor=ffffff>%c", LF);
	printf("<center>%c", LF);
	printf("<img src=%sImage/%s width=200 height=60 border=0>%c", GetBaseDir(), GetImageFileName(), LF);

	printf("<table border=0 width=480 cellspace=3>%c", LF);
	printf("<tr>%c", LF);
		printf("<td valign=buttom>%c", LF);
		printf("<img align=left border=0 src=%sImage/bookpen.gif>%c", GetBaseDir(), LF);
		printf("<br>%c", LF);
		printf("<img width=420 src=%sImage/line_ani.gif>%c", GetBaseDir(), LF);
		printf("</td>%c", LF);
	printf("</tr>%c", LF);
	printf("</table>%c", LF);
	printf("</center>%c", LF);
	printf("<center>%c", LF);
	printf("<table border=0 cellspace=3 align=absmiddle><tr><th><font size=-1>۹ȣ</font></th><th><font size=-1>۾</font></th><th><font size=-1>۾¥</font></th><th><font size=-1>Ƚ</font></th><th><font size=-1>ټ</font></th><th><font size=-1><font></th></tr></table>%c", LF);

	printf("<br><br><br><br><br>%c", LF);
        printf("<blink><font color=2e8b57 size=-1>There is no data file!!!</font></blink><br>%c", LF);
       	printf("<blink><font color=ff1493 size=-1> ۼϼž߸ մϴ!!!</font></blink>%c", LF);
	printf("<br><br><br><br><br>%c", LF);

	printf("<a href=%scgi-bin/TextHtml.Cgi?BoardNum=%d&TextNum=-1><img src=%sImage/posting.gif align=absmiddle border=0></a>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);

	printf("<p>%c", LF);
	printf("<center>%c", LF);
	printf("<img src=%sImage/line.gif>%c", GetBaseDir(), LF);
	printf("<br>%c", LF);

	printf("<font color=006400 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.13 <b>Software Engineering Lab.</b> All rights reserved.<br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", GetEmail(), GetEmail(), LF);
	printf("</font></center>%c", LF);
	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

void TextBoard::ShowError(char *str)
{
	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.13</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<br><br><br><br>%c", LF);

	printf("%s%c", str, LF);

	printf("<br><br><br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=%scgi-bin/TextBoard.Cgi?BoadNum=%d&TextNum=0><img src=%sImage/posting.gif border=0></a>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center><br>%c", LF);

	printf("<img src=%sImage/line.gif width=500><br>%c", GetBaseDir(), LF);
	printf("<font color=006400 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.13 <b>Software Engineering Lab.</b> All rights reserved.<br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/>Programmed by Kang Jul Ki</a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", GetEmail(), GetEmail(), LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
}


#ifdef COMPILE

/*
** Program Entry
*/
void main()
{
	stat		result;
	TextBoard	*MyTextBoard = NULL;

	MyTextBoard = new TextBoard;
	
	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);

	MyTextBoard->GetEnv();

	result = MyTextBoard->IsGuestBookStart();

	/*
	** Do nothing and exit if start
	** result: ERR --> start
	**         OK  --> non-start
	*/
	if (result == ERR)	exit(0);
	MyTextBoard->ShowInitHtmlPage();

	/*
	** Get iStart and iEnd
	*/
	MyTextBoard->GetScope();
	MyTextBoard->ShowBoard();

	delete	MyTextBoard;
}

#endif
