/*
	CGI Source for TextErase.cpp

	Author	: Kang Jul Ki (Master 2nd)
	E-mail	: jkkang@sel.chonbuk.ac.kr
	Homepage: http://sel.chonbuk.ac.kr/~jkkang/
	Date	: January 29, 1997
	Class	: Software Engineering Lab.
		  Dept. of Electronic Engineering
		  Chonbuk National Univ.	

	Compiler: gcc version 2.7.2
	Copyright (c) 1997, Kang Jul Ki & Software Engineering Lab
*/

#include "TextErase.h"

TextErase::TextErase()
{
}

TextErase::~TextErase()
{
}

void TextErase::GetEnv()
{
	char	*buf;
	stat	result = ERR;
	int	cl = 0;

	/*
	** Get environment variable from HTTP
	*/
	whdomain = (char *)getenv("REMOTE_HOST");
	whip	 = (char *)getenv("REMOTE_ADDR");
	buf	 = (char *)getenv("QUERY_STRING");
	cl	 = atoi(getenv("CONTENT_LENGTH"));

	for (int i=0; i<2; i++)
	{
		(iParam+i)->f_val  = (char *)makeword(buf, '&');
		(iParam+i)->f_name = (char *)makeword((iParam+i)->f_val, '=');

	}

	/*
	** Get iTextNum for deleting
	*/
	iBoardNum = atoi((iParam+0)->f_val);	
	iTextNum  = atoi((iParam+1)->f_val);	

#ifdef _DEBUG_
	printf("%s%c", (iParam+0)->f_name, LF);
	printf("%s%c<br>", (iParam+0)->f_val, LF);
#endif

	/*
	** Get content
	*/
	for (int i=0; cl && (!feof(stdin)); i++)
	{
		(iParam+i)->f_val	= fmakeword(stdin, '&', &cl);
		plustospace((iParam+i)->f_val);
		unescape_url((iParam+i)->f_val);
		(iParam+i)->f_name	= makeword((iParam+i)->f_val, '=');
#ifdef _DEBUG_
	printf("cl = %d, %s : %s%c<br>", cl, (iParam+i)->f_name, (iParam+i)->f_val, LF);
#endif
	}

	/*
	** Get password from HTTP
	*/
	strcpy(passwd, (iParam+0)->f_val);

	/*
	** Get Config from 'GuestBook.conf'
	*/
	result = ProcessConfig();
}

stat TextErase::GetFileName()
{
	sprintf(fname, "%s%s", GetBbsDir(), "guestbook.dat");

	/*
	** Open file
	*/
	fpt = fopen(fname, "r+");

#ifdef _DEBUG_
	printf("fname = %s%c", fname, CR);
#endif
	if (fpt == NULL)
	{
		char str[MAX_STRING_LEN];

		printf("Can't open %s.%c", fname, LF);
		return	ERR;
	}

	return	OK;
}

stat TextErase::IsCanErase()
{
	if (strcmp(passwd, GetPassword()))
	{
		return	ERR;
	}

	return	OK;
}

void TextErase::ReadHeader()
{
	fread(hdr, HEADER_SIZE, 1, fpt);
	iTotal	  = atoi(hdr->szTotal);
}

stat TextErase::RemoveText()
{
	char	tmp[255];
	FILE	*fpt2;
	fpos_t	pos1, pos2;
	int	iCount;
	char	rm[255];
	int	rv1, rv2;

	/*
	** iTotal == 1 and iTextNum == 1
	** remove 'guestbook.dat' and 'guestbook#.html'
	*/
	if (GetTotalText() == 1 && GetTextNum() == 1)
	{
#ifdef _DEBUG_
	printf("iTotal = %d iTextNum = %d%c<br>", GetTotalText(), GetTextNum(), LF);
#endif
		fread(rcd, RECORD_SIZE, 1, fpt);
		sprintf(rm, "%s%s", GetBbsDir(), rcd->szHtmlName);

		fclose(fpt);
		rv1 = remove(rm);
		rv2 = remove(fname);	/* remove guestbook.dat	*/

		if (rv1 == -1)
		{
			printf("1. Failed to remove %s.%c", rm, LF);
		}
		if (rv2 == -1)
		{
			printf("2. Failed to remove %s.%c", fname, LF);
		}

		ShowSuccess();

		return	OK;
	}

	/*
	** In case of no data
	*/
	if (GetTotalText() == 0)
	{
		printf("There's no data %s.%c", "guestbook.dat", LF);
		return	ERR;
	}

	sprintf(hdr->szTotal, "%d", GetTotalText()-1);	/* iTotal--	*/
	fseek(fpt, 0L, SEEK_SET);			/* go to start	*/
	fwrite(hdr, HEADER_SIZE, 1, fpt);		/* update header*/

#ifdef _DEBUG_
	printf("hdr->szTotal = %s%c", hdr->szTotal);
#endif

	if(GetTextNum() >= 1)
	{
		fseek(fpt, (long)(HEADER_SIZE+RECORD_SIZE*(GetTextNum()-1)), SEEK_SET);
#ifdef SUNOS
		_fgetpos(fpt, &pos1);
#else
		fgetpos(fpt, &pos1);
#endif

		fread(rcd, RECORD_SIZE, 1, fpt);
		sprintf(rm, "%s", rcd->szHtmlName);	/* remove 'guestbook#.html'	*/

		fseek(fpt, (long)(HEADER_SIZE+RECORD_SIZE*GetTextNum()), SEEK_SET);
#ifdef SUNOS
		_fgetpos(fpt, &pos2);
#else
		fgetpos(fpt, &pos2);
#endif

		iCount = GetTotalText() - GetTextNum();

		for (int i=0; i<iCount; i++)
		{
#ifdef SUNOS
			_fsetpos(fpt, &pos2);
#else
			fsetpos(fpt, &pos2);
#endif
			fread(rcd, RECORD_SIZE, 1, fpt);

#ifdef SUNOS
			_fgetpos(fpt, &pos2);
#else
			fgetpos(fpt, &pos2);
#endif
			sprintf(rcd->szNumber, "%d", atoi(rcd->szNumber)-1);

#ifdef SUNOS
			_fsetpos(fpt, &pos1);
			fwrite(rcd, RECORD_SIZE, 1, fpt);
			_fgetpos(fpt, &pos1);
#else
			fsetpos(fpt, &pos1);
			fwrite(rcd, RECORD_SIZE, 1, fpt);
			fgetpos(fpt, &pos1);
#endif

		}
	}

	/*
	** Update 'guestbook.dat' from temp file
	*/
	sprintf(tmp, "%s%s", GetBbsDir(), "tmp.dat");
	fpt2 = fopen(tmp, "w+");

	if (fpt2 == NULL)
	{
		printf("Can't open %s!!!%c", tmp, LF);
		return	ERR;
	}
	
	fseek(fpt, 0L, SEEK_SET);
	fread(hdr, HEADER_SIZE, 1, fpt);
	fwrite(hdr, HEADER_SIZE, 1, fpt2);

	for (int i=0; i<GetTotalText()-1; i++)
	{
		fread(rcd, RECORD_SIZE, 1, fpt);
		fwrite(rcd, RECORD_SIZE, 1, fpt2);
	}

	fclose(fpt);
	fclose(fpt2);

	rv1 = remove(fname);	/* remove guestbook.dat	*/

	if (rv1 == -1)		/* error		*/
	{
		printf("<br>3. Failed to remove %s.%c", fname, LF);
	}

	rv1 = rename(tmp, fname);

/**/	if (rv1 == -1)		/* error		*/
	{
		printf("<br>5. Failed to rename %s.%c", tmp, LF);
	}

	/*
	** Remove 'guestbook#.html'
	*/
	sprintf(tmp, "%s%s", GetBbsDir(), rm);
	rv1 = remove(tmp);

/*	printf("<br>%s was removed.%c%c", tmp, LF, LF);
*/

	if (rv1 == -1)		/* error		*/
	{
		char	str[MAX_STRING_LEN];

		sprintf(str, "<font color=454545 size=3>Filed to remove %s.</font><br>%c", tmp, LF);
		ShowError(str);
	}
	else
	{
		ShowSuccess();
	}
}
	
void TextErase::ShowSuccess()
{
	printf("<html>%c", LF);
	printf("<head>%c", LF);
	printf("<title>Խ  2.13</title>%c", LF);
	printf("</head>%c", LF);
	printf("<body bgcolor=white>%c", LF);

	printf("<br>%c", LF);
	printf("<center>%c", LF);
	printf("<br><br><br><br>%c", LF);

	printf("<font color=228b22 size=3>Successfully removed.</font><br>%c", LF);

	printf("<br><br><br><br>%c", LF);
	printf("<center>%c", LF);
	printf("<font color=4a708b size=-1>%c", LF);
	printf("<a href=%scgi-bin/TextBoard.Cgi?BoardNum=%d&TextNum=0><img src=%sImage/posting.gif border=0></a>%c", GetBaseDir(), GetBoardNum(), GetBaseDir(), LF);
	printf("<br>Click%c", LF);
	printf("</font>%c", LF);
	printf("</center><br>%c", LF);

	printf("<img src=%sImage/line.gif width=500><br>%c", GetBaseDir(), LF);
	printf("<font color=006400 size=-1>Copyright <font size=4>&copy</font> 1996 - 1997,%c", LF);
	printf("Ver 2.13 <b>Software Engineering Lab. All rights reserved.</b><br>%c", LF);
	printf("Dept. of Electronic Engineering. Chonbuk National Univ.<br>%c", LF);
	printf("<a href=http://sel.chonbuk.ac.kr/~jkkang/><blink>Programmed by Kang Jul Ki</blink></a><br>%c", LF);
	printf("<a href=mailto:%s>%s</a><br>%c", GetEmail(), GetEmail(), LF);
	printf("</font>%c", LF);
	printf("</center>%c", LF);

	printf("</body>%c", LF);
	printf("</html>%c", LF);
}

/*
** Program Entry
*/
void main()
{
	TextErase*	MyTextErase;
	stat		result;

	MyTextErase = new TextErase;

	/*
	** Mime type
	*/
	printf("Content-type: text/html%c%c", LF, LF);
	MyTextErase->GetEnv();
	MyTextErase->GetFileName();
	result = MyTextErase->IsCanErase();

	if (result == ERR)
	{
		char	str[MAX_STRING_LEN];

		sprintf(str, "<font color=228b22 size=3>Access denied.</font><br>%c\
			      <font color=454545 size=2>մ   ϴ.</font><br>", LF);

		MyTextErase->ShowError(str);
		delete	MyTextErase;

		exit(0);
	}

	MyTextErase->ReadHeader();
	MyTextErase->RemoveText();

	delete	MyTextErase;
}
